""" Addon Information """
# ------------
# EventScripts Script-Addon:    BackRaw's Zap (bZap, bzap.py, 8.2kb)
# Author:                       BackRaw - http://forums.eventscripts.com/profile.php?mode=viewprofile&u=13683
#                                         http://addons.eventscripts.com/addons/user/13683
# Version:                      1.0
# ------------

""" Imports """
# ------------
# EventScripts Core Module  - ES functionality
# ------------
import es
# ------------
# Random                    - Random choices
# ------------
import random
# ------------
# Gamethread                - Delayed functions
# ------------
from gamethread import delayed
# ------------
# ConfigObj                 - Configuration file ./addons/eventscripts/bzap/bzap_config.ini
# ------------
from configobj import ConfigObj

""" Global Variables """
# ------------
# Addon Prefix
# ------------
prefix          = '#green[#lightgreenbZap#green]#default'
# ------------
# Player dictionary to hold player-information
# ------------
player          = {}
# ------------
# Respawn Manager
# ------------
allowToRespawn  = {3:False, 2:False}
# ------------
# Zapping Manager
# ------------
zapped          = {3:False, 2:False}

""" Class - Player """
# ------------
# Player-Class for handling player-secified things
# ------------
class Player(object):
    def __init__(self, userid):
        self.userid = userid
    def fire(self, cmd):
        es.server.queuecmd('es_xfire %s %s' % (self.userid, cmd))
    def give(self, cmd):
        es.server.queuecmd('es_xgive %s %s' % (self.userid, cmd))
    def strip(self):
        es.setplayerprop(self.userid, 'CCSPlayer.m_iAccount', 16000)
        self.fire('player_weaponstrip Kill')
        self.give('player_weaponstrip')
        self.fire('player_weaponstrip Strip')
        delayed(0, self.give, 'weapon_knife')
    def rewardCheck(self):
        if es.getplayerprop(self.userid, 'CBaseEntity.m_clrRender') == -16744961:
            r       = random.randint(1, 5)
            name    = es.getplayername(self.userid)
            aDesc   = 'pwned'
            f       = returnFilter(3)
            if es.getplayerteam(self.userid) == 2:
                desc    = 'Counter-Terrorists'
            else:
                desc    = 'Terrorists'
                f       = returnFilter(2)
            if r == 1:
                aDesc = 'fried'
            elif r == 2:
                aDesc = 'zapped'
            elif r == 4:
                aDesc = 'cooked'
            elif r in (3, 5):
                aDesc = 'shafted'
            es.msg('#multi', prefix, '%s %s all the %s' % (name, aDesc, desc))
            for x in f:
                es.server.queuecmd('damage %s 100 32 %s' % (x, self.userid))
            delayed(.5, es.centermsg, '%s %s all the %s' % (name, aDesc, desc))
    def removeEntities(self):
        self.fire('weapon_c4 Kill')
        self.fire('func_bomb_target Kill')
        self.fire('func_hostage_rescue Kill')
        self.fire('hostage_entity Kill')
    def instaGib(self):
        x, y, z = es.getplayerlocation(self.userid)
        self.fire('env_blood Kill')
        self.give('env_blood')
        self.fire('env_blood addoutput "spawnflags 121"')
        self.fire('env_blood addoutput "amount %s"' % config('blood'))
        self.fire('env_blood addoutput "color 0"')
        self.fire('env_blood emitblood')
        self.fire('env_blood emitblood')
        delayed(2, self.fire, 'env_blood Kill')
        es.server.queuecmd('est_Effect 3 #a 0 "sprites/lgtning.vmt" %s %s 10000 %s %s %s 1 10 10 255 255 255 255' (x, y, x, y, z))
    def reSurrect(self):
        team = es.getplayerteam(self.userid)
        if team == 1:
            es.tell(self.userid, '#multi', prefix, 'Spectators cannot respawn!')
        elif allowToRespawn[team]:
            es.server.queuecmd('est_Spawn %s 1' % self.userid)

# ------------
# Intelligent function to return non-dead userids on a specified team
# ------------
def returnFilter(team):
    return filter(lambda x: es.getplayerteam(x) == team and not es.getplayerprop('CBasePlayer.pl.deadflag'), es.getUseridList())

# ------------
# Returns config variables
# ------------
def config(what):
    return round(float(ConfigObj(es.getAddonPath('bzap') + '/bzap_config.ini')[what]))

# ------------
# Command to trigger whenever a player touches the lightning swtich of the Ts
# ------------
def killAllTs():
    if not zapped[2]:
        zapped[2] = True
        allowToRespawn[2] = False
        es.msg('#multi', prefix, 'The Terrorists were struck down')
        for x in returnFilter(3):
            player[str(x)].rewardCheck()
        for x in returnFilter(2):
            player[str(x)].instaGib()

# ------------
# Command to trigger whenever a player touches the lightning swtich of the CTs
# ------------
def killAllCTs():
    if not zapped[3]:
        zapped[3] = True
        allowToRespawn[3] = False
        es.msg('#multi', prefix, 'The Counter-Terrorists were struck down')
        for x in returnFilter(2):
            player[str(x)].rewardCheck()
        for x in returnFilter(3):
            player[str(x)].instaGib()

# ------------
# Announce URLs and information about the game
# ------------
def round_start(ev):
    def addOutput(obj, team):
        team = ('T', 'TER') if team == 2 else ('CT', 'CT')
        obj.fire('TRIGGER_KILL_%s addoutput "OnTrigger !activator,color,255 125 0"' % team[0])
        obj.fire('TRIGGER_KILL_%s addoutput "OnTrigger point_servercommand,Command,kill%scommand"' % (team[0], team[1]))
    if es.getplayercount():
        zapped[2]           = zapped[3]         = False
        allowToRespawn[2]   = allowToRespawn[3] = False
        es.server.cmd('alias killCTcommand "es_xdoblock bzap/killAllCTs"')
        es.server.cmd('alias killTERcommand "es_xdoblock bzap/killAllTs"')
        es.msg('#multi', prefix, 'Touch the lightning switch at the enemy base to win!')
        es.msg('#multi', prefix, 'ZapDM Maps: http://www.playerofgames.net')
        x = player[str(es.getuserid())]
        x.give('point_servercommand')
        addOutput(x, 3)
        x = player[str(es.getuserid())]
        x.give('point_servercommand')
        addOutput(x, 2)
        for x in es.getUseridList():
            player[str(x)].removeEntities()
    else:
        es.msg('#multi', prefix, "Game can't be started when there are no players on the server.")

# ------------
# Add the player to the player-dictionary
# ------------
def player_activate(ev):
    userid = ev['userid']
    player[userid] = Player(userid)

# ------------
# Strip the player off his/her weapons at spawn
# ------------
def player_spawn(ev):
    userid = ev['userid']
    if int(ev['es_userteam']) > 1 and userid in player:
        player[userid].strip()

# ------------
# Handle respawning the died player and removing weapons
# ------------
def player_death(ev):
    def returnItems(what):
        entlist = es.createentitylist()
        return filter(lambda x: entlist[x]['classname'].startswith(what) and not es.getindexprop(x, 'CBaseEntity.m_hOwnerEntity') == -1, entlist)
    def removeItems():
        i = returnItems('weapon')
        i.extend(returnItems('item'))
        for x in i:
            es.server.cmd('es_xremove %s' % i)
    if allowToRespawn[int(ev['es_userteam'])]:
        userid = ev['userid']
        removeItems()
        es.tell(userid, '#multi', prefix, 'You will respawn in %s seconds!' % respawnSeconds)
        delayed(2, player[userid].fire, 'cs_ragdoll Kill')
        delayed(config('respawn'), player[userid].reSurrect)

# ------------
# Remove the player from the player-dictionary
# ------------
def player_disconnect(ev):
    del player[ev['userid']]

""" EventScripts main-control functions """
# ------------
# Add every player and set the public variable and restart the round
# ------------
def load():
    es.ServerVar('bzap_ver', 1).makepublic()
    es.server.cmd('mp_restartgame 1')
    for x in es.getUseridList():
        x = str(x)
        player[x] = Player(x)

# ------------
# Remove every player from the player-dictionary
# ------------
def unload():
    player.clear()

""" End Code """